import os
import numpy as np
import iris
import iris.cube
import iris.analysis
import warnings
import numba
import datetime
from numba import jit, njit
from numba import vectorize
from numba import guvectorize
from numba import cuda
from numba import int32, int64, float32, float64
from numba.cuda.cudadrv import driver


def compute_regsum_2D_cpu(var, basins, e1t, e2t):
    regsum = {}
    for basins, mask in basins.items():
        weighted_var = compute_weighted_var_2D(var, mask, e1t, e2t)
        regsum[basin] = np.sum(weighted_var, axis=(1,2))
    return regsum


@vectorize
def compute_weighted_var_2D(var, mask, e1t, e2t):
    weighted_var = var*mask*e1t*e2t
    return weighted_var